REBOL []

context [
	digit: charset "0123456789"
	blank: #" "
	
	days: ["Mon," "Tue," "Wed," "Thu," "Fri," "Sat," "Sun,"]
	months: ["Jan" "Feb" "Mar" "Apr" "May" "Jun" "Jul" "Aug" "Sep" "Oct" "Nov" "Dec"]
	
	set 'prefix0 func [time [time!]][
		either time/hour < 10 [head insert mold time #"0"][mold time]
	]
	
	set 'to-UTC func [date [date!]][date - date/zone]
	
	set 'to-GMT-idate func [date [date!] /UTC /local cache str new][
		cache: []
		if UTC [date: to-UTC date]
		either str: select cache date [str][	
			insert tail cache date
			insert tail cache new: reform [	;-- improvement : make string!, then insert!
				pick days date/weekday
				join any [all [date/day < 10 #"0"] ""] date/day
				pick months date/month
				date/year 
				prefix0 any [date/time 0:0]
				"GMT"
			]
			if 200 < length? cache [clear cache]	;-- 100 dates cached max
			new
		]
	]
	
	set 'to-CLF-idate func [date [date!] /local cache tmp][
		cache: [0:00:01 ""]
		either date = first cache [second cache][	
			cache/1: date
			cache/2: rejoin [
				#"["
				join any [all [date/day < 10 #"0"] ""] date/day
				slash pick months date/month slash date/year #":"
				prefix0 date/time 
				#" "
				any [all [negative? date/zone #"-"] #"+"]
				join any [all [lesser? tmp: date/zone/hour 10 #"0"] ""] tmp
				join any [all [lesser? tmp: date/zone/minute 10 #"0"] ""] tmp
				#"]"
			]
		]
	]

	set 'to-rebol-date func [data [string!] /local asc pos][
		parse/all data [thru blank data: [digit (asc: yes) | (asc: no)]]
		if pos: find data #";" [clear pos]
		if not asc [		
			data: parse data none		
			insert data second data
			change at data 3 fifth data
			remove back tail data
			data: form data			
		]
		attempt [to date! data]
	]
]